package com.iqser.red.service.persistence.management.v1.processor.service.queue;

import java.time.OffsetDateTime;
import java.time.temporal.ChronoUnit;

import org.springframework.amqp.core.Message;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.stereotype.Service;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.iqser.red.service.persistence.management.v1.processor.configuration.MessagingConfiguration;
import com.iqser.red.service.persistence.management.v1.processor.model.CvAnalysisServiceResponse;
import com.iqser.red.service.persistence.management.v1.processor.service.FileStatusProcessingUpdateService;
import com.iqser.red.service.persistence.management.v1.processor.service.FileStatusService;
import com.iqser.red.service.persistence.service.v1.api.shared.model.dossiertemplate.dossier.file.FileErrorInfo;

import io.micrometer.observation.ObservationRegistry;
import lombok.RequiredArgsConstructor;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
@RequiredArgsConstructor
public class CvAnalysisMessageReceiver {

    public static final String CV_ANALYSIS_RESPONSE_LISTENER_ID = "cv-analysis-response-listener";

    private final ObjectMapper objectMapper;
    private final FileStatusService fileStatusService;
    private final FileStatusProcessingUpdateService fileStatusProcessingUpdateService;
    private final ObservationRegistry observationRegistry;


    @SneakyThrows
    @RabbitListener(id = CV_ANALYSIS_RESPONSE_LISTENER_ID)
    public void receive(CvAnalysisServiceResponse response) {

        addFileIdToTrace(response.getFileId());
        fileStatusService.setStatusAnalyse(response.getDossierId(), response.getFileId(), false);

        log.info("Received message from exchange {} for dossierId {} and fileId {}",
                 MessagingConfiguration.CV_ANALYSIS_RESPONSE_EXCHANGE,
                 response.getDossierId(),
                 response.getFileId());
    }


    @SneakyThrows
    @RabbitListener(queues = MessagingConfiguration.CV_ANALYSIS_DLQ)
    public void handleDLQMessage(Message failedMessage) {

        var response = objectMapper.readValue(failedMessage.getBody(), CvAnalysisServiceResponse.class);
        addFileIdToTrace(response.getFileId());

        log.warn("Received message from {} for dossierId {} and fileId {}", MessagingConfiguration.IMAGE_DLQ, response.getDossierId(), response.getFileId());
        fileStatusProcessingUpdateService.analysisFailed(response.getDossierId(),
                                                         response.getFileId(),
                                                         new FileErrorInfo("cv analysis failed",
                                                                           MessagingConfiguration.IMAGE_DLQ,
                                                                           "cv-analysis-service-v1",
                                                                           OffsetDateTime.now().truncatedTo(ChronoUnit.MILLIS)));

    }


    // This can be removed if tracing is implemented in python services.
    private void addFileIdToTrace(String fileId) {

        if (observationRegistry.getCurrentObservation() != null) {
            observationRegistry.getCurrentObservation().highCardinalityKeyValue("fileId", fileId);
        }
    }

}
